{% extends "base.html" %}
{%- import "common/macros/generic.html" as mg -%}


{% block content_main %}
<div class="row">
    <div class="col-12">
        <div class="card">
            <div class="card-header">
                <div class="row">
                    <div class="col-12 col-md-6 col-xl-7">
                        <nav aria-label="breadcrumb">
                            <ol class="breadcrumb bg-transparent mb-1 mb-md-0 py-1 py-md-0 pl-1">
                                <li class="breadcrumb-item"><a href="{{ url_for('account.settings') }}">Account Settings</a></li>
                                <li class="breadcrumb-item active"> Change Password</li>
                            </ol>
                        </nav>
                    </div>
                    <div class="col-12 col-md-6 col-xl-5 text-right">
                        <div class="row">
                            <div class="col"></div>
                            <div class="col">
                                <a href="{{ url_for('account.settings') }}" class="btn btn-danger btn-sm btn-block my-2 my-md-1"><i class="fa fa-fw fa-arrow-left mr-1"></i>Go Back</a>
                            </div>
                        </div>
                    </div>
                </div>
                <h4 class="card-title mt-1 mt-md-0"> Change Password</h4>
            </div>
            <div class="card-body">
                <form data-account-change-password method="POST" action="{{ url_for('account.save') }}">
                    <input type="hidden" name="_id" value="{{ record._id }}" />
                    <div class="row">
                        <div class="col-12 col-md-6 offset-md-3">
                            <div class="row">
                                <div class="col-12">
                                    <div class="form-group">
                                        <label>{{ "password"|normalize|title }}*</label>
                                        <input type="password" name="password" class="form-control" maxlength="75" placeholder="Hidden" value="" data-default-value="" />
                                        <a href="javascript:;" class="float-right mt-2" data-users-toggle="generate_password"><i class="fa fa-fw fa-random"></i> Generate Password</a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <button type="submit" class="invisible"></button>
                </form>
            </div>
            <div class="card-footer text-right">
                <button type="button" class="btn btn-secondary btn-sm mr-2" data-reset-form="form[data-account-change-password]"><i class="fa fa-undo"></i> Reset</button>
                <button type="button" class="btn btn-info btn-sm" data-submit-form="form[data-account-change-password]">Submit</button>
            </div>
        </div>
    </div>
</div>
{% endblock %}


{% block scripts %}
    <script>
        function generate_alphanum(length) {
            let result = '';
            if (!isDefined(length)) {
                length = 8;
            } else if (length > 255) {
                length = 255;
            }
            let chars = 'atuvK12bcdewPQRSTUVfFGHIJopq7xyzAhijklmnWXr456YZ890s3BCDELMNOg';
            for (var i =0; i < length; i++) {
                result += chars.charAt(Math.floor(Math.random() * chars.length));
            }
            return result;
        }

        $dom.document.on('click', '[data-users-toggle="generate_password"]', function() {
            let password = generate_alphanum();
            $('[data-account-change-password]form [name="password"]').val(password);
            Swal.fire('Password Generated', password, 'success');
        });

        $dom.document.on('submit', '[data-account-change-password]form', function(e) {
            e.preventDefault();
            let $form = $(this);
            $.post($form.attr('action'), $form.serialize(), function() {})
            .done(function(response) {
                if (isDefined(response.success) && response.success) {
                    Swal.fire({
                        title: 'Successfully Changed Password',
                        text: '',
                        type: 'success'
                    });
                }
                else {
                    Swal.fire('Error', response.error, 'error');
                }
            })
            .always(function() {
                $dom.document.find('[data-submit-form]').ladda('stop');
            })
            .fail(function() {
                Swal.fire('Error', 'Server Error', 'error');
            });
        });
    </script>
{% endblock %}
